/**
 ** PosPartida.java
 **
 ** Copyright (C) 1992, 1999, 2007, 2011, 2012 Mariano Alvarez Fernandez
 ** [e-mail: malfer at telefonica.net]
 **
 ** This file is part of the Parchis4A program.
 **
 ** Parchis4A is free software: you can redistribute it and/or modify
 ** it under the terms of the GNU General Public License as published by
 ** the Free Software Foundation, either version 3 of the License, or
 ** (at your option) any later version.
 **
 ** Parchis4A is distributed in the hope that it will be useful,
 ** but WITHOUT ANY WARRANTY; without even the implied warranty of
 ** MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 ** GNU General Public License for more details.
 **
 ** You should have received a copy of the GNU General Public License
 ** along with Parchis4A.  If not, see <http://www.gnu.org/licenses/>.
 **
 **/

package com.fgrim.parchis4a;

public class PosPartida extends DefPartida {
	
	public boolean jgha_salido[];
	public int jgha_terminado[];
	public int sig_pos_fin;
	public PosFicha pos_ficha[][];
	public int nfcasa[];
	public int nfmeta[];
	public int distancia[];
	
	public int turno;
	public int nseises;
	public int nfmovida;

	Tablero mTbl;
	
	public int estDado[][];
	public int estTotDado[];
	public int estPasa[];
	public int estCome[];
	public int estComida[];
	public int estACasa[];
	
	public PosPartida() {
		super();
		jgha_salido = new boolean[4];
		jgha_terminado = new int[4];
		pos_ficha =  new PosFicha[4][4];
		nfcasa = new int[4];
		nfmeta = new int[4];
		estDado = new int[4][6];
		estTotDado = new int[4];
		estPasa = new int[4];
		estCome = new int[4];
		estComida = new int[4];
		estACasa = new int[4];
		distancia = new int[4];
		mTbl = new Tablero();
	}

	public void set(PosPartida auxPP) {
		this.set((DefPartida)auxPP);
		for (int c=AMAR; c<=VERD; c++) {
//			tipo_jugador[c] = auxPP.tipo_jugador[c];
//			nivel_maquina[c] = auxPP.nivel_maquina[c];
			jgha_salido[c] = auxPP.jgha_salido[c];
			jgha_terminado[c] = auxPP.jgha_terminado[c];
			for (int nf=0; nf<4; nf++) {
				pos_ficha[c][nf] = new PosFicha();
				pos_ficha[c][nf].setPosicion(auxPP.pos_ficha[c][nf]);
			}
			nfcasa[c] = auxPP.nfcasa[c];
			nfmeta[c] = auxPP.nfmeta[c];
			distancia[c] = auxPP.distancia[c];
			for (int d=0; d<6; d++)
				estDado[c][d] = auxPP.estDado[c][d];
			estTotDado[c] = auxPP.estTotDado[c];
			estPasa[c] = auxPP.estPasa[c];
			estCome[c] = auxPP.estCome[c];
			estComida[c] = auxPP.estComida[c];
			estACasa[c] = auxPP.estACasa[c];
		}
		sig_pos_fin = auxPP.sig_pos_fin;
		turno = auxPP.turno;
		nseises = auxPP.nseises;
		nfmovida = auxPP.nfmovida;
//		fin_rapido = auxPP.fin_rapido;
//		finrobot_rapido = auxPP.finrobot_rapido;
//		dado_manual = auxPP.dado_manual;
//		num_jg = auxPP.num_jg;
//		num_jgh = auxPP.num_jgh;
//		num_jgr = auxPP.num_jgr;
		mTbl.vaciaCasillas();
		mTbl.setPosPartida(this);
	}
	
    protected int[] pos_ficha_to_array() {
    	int pfa[] = new int[4*4*3];
    	int k = 0;
		for (int c=AMAR; c<=VERD; c++) {
			for (int nf=0; nf<4; nf++) {
				pfa[k++] = pos_ficha[c][nf].lugar;
				pfa[k++] = pos_ficha[c][nf].pos;
				pfa[k++] = pos_ficha[c][nf].ind;
			}
		}
    	return pfa;
    }
    
    protected void array_to_pos_ficha(int pfa[]) {
    	int k = 0;
		for (int c=AMAR; c<=VERD; c++) {
			for (int nf=0; nf<4; nf++) {
				pos_ficha[c][nf] = new PosFicha();
				pos_ficha[c][nf].lugar = pfa[k++];
				pos_ficha[c][nf].pos = pfa[k++];
				pos_ficha[c][nf].ind = pfa[k++];
			}
		}
    }
    
	public void posInicial(DefPartida defP) {
		this.set(defP);
		for (int c=AMAR; c<=VERD; c++) {
			jgha_salido[c] = false;
			jgha_terminado[c] = -1;
			for (int nf=0; nf<4; nf++) {
				pos_ficha[c][nf] = new PosFicha(PosFicha.CASA, 0, nf);
			}
			nfcasa[c] = 4;
			nfmeta[c] = 0;
			for (int d=0; d<6; d++)
				estDado[c][d] = 0;
			estTotDado[c] = 0;
			estPasa[c] = 0;
			estCome[c] = 0;
			estComida[c] = 0;
			estACasa[c] = 0;
			distancia[c] = 320;
		}
		
		sig_pos_fin = 0;
		turno = VERD; // so next player is AMAR!
        nseises = 0;
        
		mTbl.vaciaCasillas();
		mTbl.setPosPartida(this);
		this.avanzaTurno();
	}
	
	public boolean haComenzado() {
		for (int c=AMAR; c<=VERD; c++) {
	        if (nfcasa[c] < 4) return true;
		}
		return false;
	}
	
	public boolean haTerminado() {
		for (int c=AMAR; c<=VERD; c++) {
		    if (tipo_jugador[c] != DefPartida.NOJUEGA && jgha_terminado[c] < 0) return false;
		}
		return true;
	}

	public int calculaDistancia(int color) {
		int distancia = 0;
		for (int nf=0; nf<4; nf++) {
			if (pos_ficha[color][nf].lugar == PosFicha.META)
				continue;
			else if (pos_ficha[color][nf].lugar == PosFicha.LLEGADA)
				distancia += 5 + 7 - pos_ficha[color][nf].pos;
			else if (pos_ficha[color][nf].lugar == PosFicha.CORREDOR) {
				int pos = pos_ficha[color][nf].pos;
		    	if (pos < Jugada.cent[color]) pos += 68;
		    	pos = pos - (17 * color);
		    	distancia += 5 + 7 + 68 - pos; 
			} else // CASA
				distancia += 5 + 7 + 68;
		}
		return distancia;
	}

	public void actualizaDistancias() {
		for (int c=AMAR; c<=VERD; c++) {
			distancia[c] = calculaDistancia(c);
		}
	}

    private void sumaTurno() {
		if (turno == VERD)
			turno = AMAR;
		else
			turno++;
    }
    
	public boolean avanzaTurno() {
		boolean encontrado = false;

		nseises = 0;
		nfmovida = -1;
		sumaTurno();
		
		for (int i=0; i<4; i++) {
			if (tipo_jugador[turno] != DefPartida.NOJUEGA && jgha_terminado[turno] < 0) {
				encontrado = true;
				break;
			} else
				sumaTurno();
		}
		
		return encontrado ? true : false;
	}

	public boolean compruebaFinalRapido() {
		
		if (fin_rapido && num_jg > 1) {
		    if (num_jg == sig_pos_fin + 1) {
		    	jgha_terminado[turno] = sig_pos_fin++;
				return true;
		    }
		}
		
		if (finrobot_rapido && num_jgr > 0) {
			int njght = 0;
			int njgrt = 0;
			for (int c=AMAR; c<=VERD; c++) {
				if (jgha_terminado[c] >= 0) {
					if (tipo_jugador[c] == DefPartida.PERSONA)
						njght++;
					else if (tipo_jugador[c] == DefPartida.MAQUINA)
						njgrt++;
				}
			}
			if ((num_jgh > 0 && njght == num_jgh)) { // han terminado todos los humanos
//				(num_jgh == 0 && njgrt > 0)) {       // o solo robots y ya ha entrado uno
				acabaPartida();
				return true;
			}
		}
		return false;
	}

	public void acabaPartida() {
		int njgt = 0;
		int ljgst[] = new int[4];
		int njgst = 0;
		for (int c=AMAR; c<=VERD; c++) {
			if (jgha_terminado[c] >= 0) {
				njgt++;
			} else if (tipo_jugador[c] != DefPartida.NOJUEGA) {
				ljgst[njgst] = c;
				njgst++;
			}
		}
		if (njgst == 1) { // solo queda uno
		    jgha_terminado[ljgst[0]] = sig_pos_fin++;
		} else if (njgst > 1) { // quedan 2 o 3 (o 4 por si acaso)
			int dist[] = new int[4];
			for (int k=0; k<njgst; k++) {
				dist[k] = distancia[ljgst[k]];
			}
			for (int i=0; i<njgst; i++) {
				int minimo = 1000;
				int pos_minimo = 0;
				for (int k=0; k<njgst; k++) {
					if (dist[k] < minimo) {
						minimo = dist[k];
						pos_minimo = k;
					}
				}
				dist[pos_minimo] = 2000;
			    jgha_terminado[ljgst[pos_minimo]] = sig_pos_fin++;
			}
		}
	}
	
    public int realizaJugada(Jugada jg) {
    	nfmovida = jg.nficha;

    	/* caso especial a casa por tres seises */
    	if (jg.acasa) {
    		estACasa[jg.cjugador]++;
    		if (jg.origen.lugar == PosFicha.CORREDOR &&
    			jg.destino.lugar == PosFicha.CASA) { // por si acaso
    			mTbl.vaciaCasillaCorredor(this, jg.origen.pos, jg.origen.ind);
    	    	/* actualiza resumen */
    	    	nfcasa[jg.cjugador]++;
    	    	/* coloca la nueva posicion en los datos de la ficha */
    	    	pos_ficha[jg.cjugador][jg.nficha].setPosicion(jg.destino);
    	    	/* coloca la ficha en la nueva posicion */
    	    	mTbl.casa[jg.cjugador].cf[jg.destino.ind] = jg.cjugador;
    	    	mTbl.casa[jg.cjugador].nf[jg.destino.ind] = jg.nficha;
    		}
    		return 0;
    	}

    	/* actualiza resumen y estadística */
    	if (jg.entra) nfcasa[jg.cjugador]--;
    	if (jg.meta) nfmeta[jg.cjugador]++;
    	if (jg.come) {
    		estCome[jg.cjugador]++;
    		estComida[jg.cjugdcom]++;
    	}
    	if (jg.come2) {
    		estCome[jg.cjugador]++;
    		estComida[jg.cjugdcom2]++;
    	}

    	/* libera la posicion inicial */
    	if (jg.origen.lugar == PosFicha.CASA)
    		mTbl.vaciaCasillaCasa(this, jg.cjugador, jg.origen.ind);
    	else if (jg.origen.lugar == PosFicha.CORREDOR)
    		mTbl.vaciaCasillaCorredor(this, jg.origen.pos, jg.origen.ind);
    	else /* no puede ser la META, luego es la LLEGADA */
    		mTbl.vaciaCasillaLLegada(this, jg.cjugador, jg.origen.pos, jg.origen.ind);
    	
    	/* coloca la nueva posicion en los datos de la ficha */
    	pos_ficha[jg.cjugador][jg.nficha].setPosicion(jg.destino);
    	
    	/* coloca la ficha en la nueva posicion y mira si se come ficha */
    	boolean ficha_comida = false;
    	boolean en_meta = false;
    	boolean jfin = false;
    	if (jg.destino.lugar == PosFicha.CORREDOR) {
    		ficha_comida = mTbl.aCasa(this, jg.destino.pos, jg.destino.ind);
    		mTbl.corredor[jg.destino.pos].cf[jg.destino.ind] = jg.cjugador;
    		mTbl.corredor[jg.destino.pos].nf[jg.destino.ind] = jg.nficha;
    	} else if (jg.destino.lugar == PosFicha.LLEGADA) {
    		mTbl.llegada[jg.cjugador][jg.destino.pos].cf[jg.destino.ind] = jg.cjugador;
    		mTbl.llegada[jg.cjugador][jg.destino.pos].nf[jg.destino.ind] = jg.nficha;
    	} else { /* debe ser la meta */
    		mTbl.meta[jg.cjugador].cf[jg.destino.ind] = jg.cjugador;
    		mTbl.meta[jg.cjugador].nf[jg.destino.ind] = jg.nficha;
    		if (nfmeta[jg.cjugador] < 4)
    			en_meta = true;
    		else {
    			jfin = true;
    			jgha_terminado[jg.cjugador] = sig_pos_fin++;
    		}
    	}
    	
    	/* si es el primer 5 hay que sacar dos fichas */
    	if (jg.entra2) {
    		nfcasa[jg.cjugador]--;
    		mTbl.vaciaCasillaCasa(this, jg.cjugador, 0); // ind 0 porque se movieron
    		pos_ficha[jg.cjugador][1].setPosicion(jg.destino2);
    		/*ficha_comida = no se mira porque si comia al menos una ya esta contada */ 
    		mTbl.aCasa(this, jg.destino2.pos, jg.destino2.ind);
    		mTbl.corredor[jg.destino2.pos].cf[jg.destino2.ind] = jg.cjugador;
    		mTbl.corredor[jg.destino2.pos].nf[jg.destino2.ind] = jg.nficha2;
    		jgha_salido[jg.cjugador] = true;
    	}
    	/* devuelve valor de dado de la jugada */
    	if (ficha_comida) return 20;
    	if (en_meta) return 10;
    	if (jfin) return -1; /* indica que ya han llegado todas sus fichas */
    	return 0;
    }

	public String impEstadisticas() {
		String s;
		
		s = "";
		for (int c=AMAR; c<=VERD; c++) {
			for (int ind=0; ind<6; ind++) {
				s += (ind+1) + ":" + estDado[c][ind] + " "; 
			}
			s += "P:" + estPasa[c] + " ";
			s += "C:" + estCome[c] + " ";
			s += "Cmd:" + estComida[c] + " ";
			s += "AC:" + estACasa[c] + "\n";
		}
		return s;
	}

}
